<?php
/**
 * @package Pontopass
 * @version 1.0.2
 */

/*
Plugin Name: Pontopass
Plugin URI: http://pontopass.com
Description: Integra o sistema de login do Wordpress com a proteção e gerenciamento de autenticações do Pontopass (www.pontopass.com) - <a href="http://docs.pontopass.com/guia-de-instalacao-do-plugin-pontopass-para-wordpress/" target="_blank">Clique aqui para ver o Guia de Instalação</a>
Version: 1.0.2
Author URI: http://pontopass.com/
*/


require('pontopass_sdk.php');
include ABSPATH.'/wp-includes/class-phpass.php';
global $pontopass_widget;


function init_scripts() {
$currentFile = $_SERVER["PHP_SELF"];
$parts = Explode('/', $currentFile);
$currentphp = $parts[count($parts) - 1];

if(is_admin() || $currentphp == "wp-login.php") {
wp_enqueue_script('jquery');
wp_register_script( 'pontopass', plugins_url( '/js/pontopass.js', __FILE__ ), null, "1.0.0" );
wp_enqueue_script('pontopass');
}    

}



function pontopass_auth ( $user, $username, $password ){
global $pontopass_widget;


$status = get_option('pontopass_status');
if(empty($status) || $status == "off") return $user;

if((isset($_POST['check'])) && (isset($_POST['login'])) && (isset($_POST['pontopass_session']))) { 

	$login = $_POST['login'];
	$user = get_userdatabylogin( $login );
	if(is_wp_error($user)) return new WP_Error( 'denied', __("<strong>ERROR</strong>:  Erro durante verificAção com Pontopass (Usuario inexistente)"));
	
	
	$preHash = $user->user_pass.get_option('pontopass_apikey');
	$wp_hasher = new PasswordHash(8, TRUE);
	$check = $wp_hasher->CheckPassword($preHash, $_POST['check']);
	if(!$check) return new WP_Error( 'denied', __("<strong>ERROR</strong>:  Erro durante verificAção com Pontopass")); 

	
	$auth = new PontopassAuth(get_option('pontopass_apiid'),get_option('pontopass_apikey'),get_option('pontopass_apihost'));
	$auth->session = $_POST['pontopass_session'];

	if($auth->CheckAnswer($login)) {
			return $user;

	} else {
		$user = new WP_Error( 'denied', __("<strong>ERROR</strong>:  Erro durante verificAção com Pontopass (Sessão não aprovada.)"));  return $user; 
	}

	

}



if($_SERVER['REQUEST_METHOD'] === 'GET') return new WP_Error();


if(empty($username) || empty($password)) return;



	$check = wp_authenticate_username_password( NULL, $username, $password);
	if(is_wp_error($check)) return new WP_Error( 'denied', __("<strong>ERROR</strong>:  Usuário ou senha inválidos.")); 
	
  
	$user = new WP_Error(); 


	$auth = new PontopassAuth(get_option('pontopass_apiid'),get_option('pontopass_apikey'),get_option('pontopass_apihost'));
	$auth->init($username);
	

	$userinfo = get_userdatabylogin( $username );

	$hashedPassword = wp_hash_password($userinfo->user_pass.get_option('pontopass_apikey'),get_option('pontopass_apihost'));


	$post['check'] = $hashedPassword;
	$post['login'] = $username;


	$pontopass_widget = $auth->widget(500,500,curPageURL(),"POST",$post);

	return $user;
	  	 
}

function curPageURL() {
	$pageURL = 'http';
	if ($_SERVER["HTTPS"] == "on") {$pageURL .= "s";}
	$pageURL .= "://";
	if ($_SERVER["SERVER_PORT"] != "80") {
		$pageURL .= $_SERVER["SERVER_NAME"].":".$_SERVER["SERVER_PORT"].$_SERVER["REQUEST_URI"];
	} else {
		$pageURL .= $_SERVER["SERVER_NAME"].$_SERVER["REQUEST_URI"];
	}
	return $pageURL;
}

function pontopass_banner() {

$bannerstatus = get_option("pontopass_banner");

if($bannerstatus == "show") { 
$file = dirname(__FILE__) . '/pontopass.php';
$plugin_url = plugin_dir_url($file);

echo '<div style="width:100%; text-align:center; padding-top: 8px;"><a href="http://pontopass.com" target="_blank"><img src="'.$plugin_url.'/img/logo_pontopass.png"></a></div>';
}


}
function pontopass_widget() { 
global $pontopass_widget;
if(!empty($pontopass_widget)) { 


 echo "<script>jQuery('#login, #login h1 a').width(500); jQuery('form, .forgetmenot, .submit').fadeOut(); jQuery('#loginform').before(\"$pontopass_widget\");</script>"; 

}



}


function pontopass_saveprofile( $user_id ) {
    
   if ( !current_user_can( 'edit_user', $user_id ) )
       return FALSE;
    

  // =========================================
  // Exclusao de dispositivo
  // ==========================================
    $removeid = $_POST['pontopass_removeid'];
    // Temos device a excluir?
   if(!empty($removeid)) { 
   	$user = get_userdata($user_id);
   
    // Verifica se usuario editado  dono do device a ser excluido, se sim, o remove
	$pontopass = new PontopassUser(get_option('pontopass_apiid'),get_option('pontopass_apikey'),get_option('pontopass_apihost'));
	$pontopass->login = $user->user_login;
	if($pontopass->checkMethod($removeid)) $pontopass->deleteDevice($removeid);
		
		}


 // =============================
 // Cadastramento de novo device
 // =============================

		if(strlen((int)$_POST['pontopass_number']) > 9) {
			$user = get_userdata($user_id);
			$pontopass = new PontopassUser(get_option('pontopass_apiid'),get_option('pontopass_apikey'),get_option('pontopass_apihost'));
			$pontopass->login = $user->user_login;
			$pontopass->create($user->display_name);
		

			$description = ($_POST['pontopass_desc'])?$_POST['pontopass_desc']:"Dispositivo";

		
			$pontopass->insertDevice(1,(int)$_POST['pontopass_number'],$description);
		
			
			if($_POST['pontopass_type'] == 'mobile') {
				
				$pontopass->insertDevice(2,(int)$_POST['pontopass_number'],$description);
				$pontopass->insertDevice(3,(int)$_POST['pontopass_number'],$description);
			}             

   
}

}



function user_devices_form( $user ) {

$pontopass = new PontopassUser(get_option('pontopass_apiid'),get_option('pontopass_apikey'),get_option('pontopass_apihost'));
$pontopass->login = $user->user_login;
$devices = $pontopass->listMethods();

// ==============================================
// TABLE HEADER
// ===============================================
?>
<h3>Dispositivos e Formas de Confirmação de Autenticação (Pontopass)</h3>
<table class="wp-list-table widefat fixed posts">
	<thead>
		<tr>
			<th><?php _e('Tipo de Confirmação', 'pippinw'); ?></th>
			<th><?php _e('Identificação do Dispositivo', 'pippinw'); ?></th>
			<th><?php _e('Ações', 'pippinw'); ?></th>
		</tr>
	</thead>
	<tfoot>
		<tr>
			<th><?php _e('Tipo de Confirmação', 'pippinw'); ?></th>
			<th><?php _e('Identificação do Dispositivo', 'pippinw'); ?></th>
			<th><?php _e('Ações', 'pippinw'); ?></th>
		</tr>
	</tfoot>
	<tbody>

<?php
$alt = false;
$tipo = Array(1 => "Ligação Telefônica", 2 => "Codigo de Confirmação por Mensagem de Texto (SMS)", 3 => "Confirmação por Aplicativo Mobile", 4 => "Codigo de Confirmação por Mobile Token");

foreach($devices as &$method) {
$identificacao = esc_html($method->description);
if(($method->token_type == 1) || ($method->token_type == 2)) $identificacao .= " (".esc_html($method->number).")";
if(!empty($method->token_description)) {

$description = esc_html("Descricao: ".$method->token_description);

}

$alt = !$alt;

// ==========================================================
// ROW
// ===========================================================
?>
			<tr class="<?php echo ($alt)?'alternate':'';?>">
				<td><?=$tipo[$method->token_type]?></td>
				<td><?=$identificacao?></td>
				<td><span><a  onclick="removeDevice(<?=$method->id?>)">Remover Dispositivo</a></span></td>
			</tr>
 <?php


}


// ==========================================================
// TABLE FOOTER
// ===========================================================

?>

    </tbody>
</table></br>



<?php



// ==========================================================
// FORM NEW DEVICE
// ===========================================================

?>
<input class="button button-primary" onclick="jQuery('#pontopass_novodevice').slideDown();jQuery(this).hide();" type="button" value="Cadastrar Novo Dispositivo" name="novodevice">
<div id="pontopass_novodevice" style="display: none;" >
	<h3>Cadastramento de Novo Dispositivo para Confirmação de Autenticação (Pontopass)</h3>
    <table class="form-table" >
        <tr valign="top">
        <th scope="row" style="width:400px;">Descricao do Dispositivo</th>
        <td><input type="text" name="pontopass_desc" value="Celular" /></td>
        </tr>
         
        <tr valign="top">
        <th scope="row">Número do Telefone <br><i>(formato:  [codigo do pais][codigo da cidade][numero do telefone]  <br> ex: 551130302020 )</i></th>
        <td><input type="text" name="pontopass_number" value="<?php echo get_option('some_other_option'); ?>" /></td>
        </tr>
        
        <tr valign="top">
        <th scope="row">Tipo de Dispositivo</th>
        <td><select name="pontopass_type"><option value="mobile" selected>Celular</option><option value="fixo">Telefone Fixo</option></select>
        </td>
        </tr>
    </table>
<br/>
</div>
<br/>
<?php
return;
}


function pontopass_admin_menu() {

add_options_page( "Pontopass", "Pontopass", 'activate_plugins', "pontopass", "pontopass_admin_page");

}


function pontopass_admin_page() {


$apiid = get_option('pontopass_apiid');
$apikey = get_option('pontopass_apikey');
$apihost = get_option('pontopass_apihost');
$apistatus = get_option('pontopass_status');


if((!ctype_xdigit($apiid)) || (strlen($apiid) != 64)) { $error = true; $apiid = ""; delete_option( "pontopass_apiid");  }
if((!ctype_xdigit($apikey)) || (strlen($apikey) != 64)) { $error = true; $apikey = "";delete_option( "pontopass_apikey");delete_option( "pontopass_apikey");  } 
if(substr($apihost,-14,14) != ".pontopass.com") { $error = true; $apihost = ""; delete_option( "pontopass_apihost"); }
if(empty($apistatus) || $apistatus == "off") $error = true;


if(!isset($error)) {
	
	$current_user = wp_get_current_user();


	$pontopassAuth = new PontopassAuth($apiid,$apikey,$apihost);
	if($pontopassAuth->init($current_user->user_login) && $pontopassAuth->status != 30) {
		
		
	// Admin ja tem devices?
	$pontopassUser = new PontopassUser($apiid,$apikey,$apihost);
	$pontopassUser->login = $current_user->user_login;
	$devices = $pontopassUser->listMethods();

	if(count($devices) <= 0)  $warndevices = true; 
	
	} else {
		delete_option( "pontopass_apiid");
		delete_option( "pontopass_apikey");
		$error = true;
	}

}


if($error) {
update_option("pontopass_status","off");
$requisitos = array();

$requisitos[] = 'Definir <b>"Estado do Plugin"</b> como <b>"Habilitado"</b>';
if(empty($apiid)) $requisitos[] = 'Configurar sua API ID corretamente em <b>"Identificação"</b>';
if(empty($apikey)) $requisitos[] = 'Configurar sua Chave de API corretamente em <b>"Chave"</b>';
if(empty($apihost)) $requisitos[] = 'Configurar o Host de seu servidor de API em <b>"Host"</b>';

}




?>
<div id="icon-options-general" class="icon32"><br /></div><h2>Configurações do Pontopass</h2>
<br>
<form id="pontopass-form" action="options.php" method="post">
 <?php wp_nonce_field('update-options') ?> 
        <input type="hidden" name="action" value="update" />  
            <input type="hidden" name="page_options" value="pontopass_apikey,pontopass_apiid,pontopass_apihost,pontopass_status,pontopass_banner" /> 

<?php
if($error) {
?>
	  <p> A integração com o Pontopass <b>não está em funcionamento</b>. Os seguintes requisitos estão pendentes:</p>
	  <ul>
<?php foreach($requisitos as $requisito) echo "<li>- $requisito</li>"; ?>
	  </ul><br/>
<?php
}  else { 

$validkey = true;

}

if($warndevices) {

echo "<p style='padding-top:30px'><b>Atenção:</b> Você ainda não cadastrou dispositivos em sua conta. Para cadastrá-los, <a href='profile.php'>edite seu perfil</a></p>";

}       

?>



	<div style="padding-top:15px">
    <h3>Opções da Integração</h3>
    Caso não possua uma integração criada em sua conta Pontopass, cadastre uma nova no <a href="https://panel.pontopass.com" target="_blank">Painel do Cliente Pontopass</a>. Para mais informações, <a href="http://docs.pontopass.com/como-obter-a-chave-de-integracao/" target="_blank">clique aqui.</a><br/>
    <br/>

    <table class="form-table" >
           <tr valign="top">
        <th scope="row" >Estado do Plugin</th>
        <td><select name="pontopass_status"><option value="on" <?php if(get_option('pontopass_status') == 'on') echo "SELECTED"; ?> >Habilitada</option><option value="off" <?php if(get_option('pontopass_status') == 'off') echo "SELECTED"; ?>>Desabilitada</option></select></td>
        </tr>
         

        <tr valign="top">
        <th scope="row" >Identificação</th>
        <td><input type="text" style="width:400px" name="pontopass_apiid" value="<?php echo esc_attr(get_option('pontopass_apiid')); ?>" /></td>
        </tr>
         
        <tr valign="top">
        <th scope="row">Chave<br></th>
        <td><input type="text" style="width:400px" name="pontopass_apikey" value="<?php echo esc_attr(get_option('pontopass_apikey')); ?>" /></td>
        </tr>
        
        <tr valign="top">
        <th scope="row">Host<br></th>
        <td><input type="text" style="width:400px" name="pontopass_apihost" value="<?php echo esc_attr(get_option('pontopass_apihost')); ?>" /></td>
        </tr>
        
        <tr valign="top">
        <th scope="row">Estado da Integração<br></th>
        <td><?php if($validkey) echo "<span style='color:green'>Credenciais de acesso são válidas.</span>"; else echo "<span style='color:red'>Credenciais de acesso inválidas.</span>"; ?></td>
        </tr>

    </table></div>

    <div style="padding-top:30px">
    <h3>Outras opções</h3>
    <table class="form-table" >
        <tr valign="top">
        <th scope="row" >Exibir mensagem de "Protegido por Pontopass" no formulário de login?</th>
        <td><input type="radio" name="pontopass_banner" <?php if(get_option('pontopass_banner') == 'show') echo "checked"; ?> value="show"> Sim<br/><input type="radio" name="pontopass_banner" <?php if(get_option('pontopass_banner') == 'hide') echo "checked"; ?> value="hide"> Não</td>
        </tr>
     
    </table>
    <?php submit_button(); ?>
    </form>
    </div>
    <hr>
    <b><a href="http://docs.pontopass.com/guia-de-instalacao-do-plugin-pontopass-para-wordpress/" target="_blank">Guia do Plugin</a> | <a href="http://pontopass.com/" target="_blank">Site do Pontopass</a> |  <a href="http://docs.pontopass.com/" target="_blank">Support Center</a>  </b><br/>
    

<?php


}


add_action( 'admin_init', 'my_admin_init' );
function my_admin_init() {
    register_setting( 'pontopass', 'my-setting' );
    add_settings_section( 'section-one', 'Section One', 'section_one_callback', 'my-plugin' );
    add_settings_field( 'field-one', 'Field One', 'field_one_callback', 'my-plugin', 'section-one' );
}


	

// ACTIONS/FILTERs:
add_action('login_footer','pontopass_widget',40);
add_action('login_footer','pontopass_banner',10);

add_action('admin_menu', 'pontopass_admin_menu');

remove_action('authenticate', 'wp_authenticate_username_password', 40);

add_filter( 'authenticate', 'pontopass_auth', 40, 3);
add_action( 'show_user_profile', 'user_devices_form', 10 );
add_action( 'edit_user_profile', 'user_devices_form', 10 );
add_action( 'personal_options_update', 'pontopass_saveprofile', 10, 1 );
add_action( 'edit_user_profile_update', 'pontopass_saveprofile', 10, 1 );
add_action('init', 'init_scripts');

?>
